#include <dlplus.h>

void dlplus_start(void) {
        start_dlplus=end_dlplus=NULL;
}
 
dlplus_lib *dlplus_open(char *lib, char *flag) {
	dlplus_lib *tmp;

        tmp=dlplus_search(lib);
        if(tmp) return tmp;

	if((tmp=(dlplus_lib *)malloc(sizeof(dlplus_lib)))==NULL) return NULL;
	if((tmp->lib=(char *)malloc(strlen(lib)*sizeof(char)))==NULL) {
		free(tmp);
        	return NULL;
	}
	if((tmp->flag=(char *)malloc(strlen(flag)*sizeof(char)))==NULL) {
		free(tmp->lib);
		free(tmp);
        	return NULL;
	}

        strcpy(tmp->lib,lib);
        strcpy(tmp->flag,flag);
        tmp->next=NULL;

	if(dlplus_compile(tmp)) {
		free(tmp->lib);
		free(tmp->flag);
		free(tmp);
		return NULL;
        }
 
	if(start_dlplus==NULL) end_dlplus=NULL;

	if(end_dlplus==NULL) {
		tmp->prev=NULL;
		end_dlplus=tmp;
		start_dlplus=tmp;
		return tmp;
	}

	end_dlplus->next=tmp;
	tmp->prev=end_dlplus;
	end_dlplus=tmp;
	return tmp;
}

dlplus_lib *dlplus_search(char *lib) {
        dlplus_lib *tmp;

        if(!start_dlplus) return NULL;

        tmp=start_dlplus;
        while(tmp) {
                if(!strcmp(tmp->lib,lib)) return tmp;
                tmp=tmp->next;
        }
        return NULL;
}

void dlplus_close(dlplus_lib *lib) {

	if(!lib)		return;
        if(!end_dlplus)		return;
        if(!start_dlplus)	return;

	free(lib->lib);
	free(lib->flag);

	if(lib->prev) lib->prev->next=lib->next;
	else {
		start_dlplus=lib->next;
		if(start_dlplus) start_dlplus->prev=NULL;
	}

	if(lib->next) lib->next->prev=lib->prev;
	else end_dlplus=lib->prev;
	free(lib);
}

int dlplus_compile(dlplus_lib *lib) {
	char tmp[2000];

	if(lib->handle)	dlclose(lib->handle);
	
	sprintf(tmp,"%s %s %s",COMPILE1,lib->lib,lib->flag);
	system(tmp);
	sprintf(tmp,"%s %s",COMPILE2,lib->flag);
	system(tmp);
	lib->handle=dlopen(PATH_SO,RTLD_LAZY);
	unlink(PATH_SO);
	unlink(PATH_O);
	if(!lib->handle) return 1;
	else return 0;
}

int dlplus_exec(dlplus_lib *lib, char *func) {
	void (*tmp)(void); /* Per adesso :/ */
	tmp=dlsym(lib->handle,func);
	if(!tmp) return 1;
	(*tmp)();
	return 0;
}
